<?php

# get correct id for plugin
$thisfile = basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile, //Plugin id
	'Imagizer', 	//Plugin name
	'0.1', 		//Plugin version
	'Alexey Rehov',  //Plugin author (nickname: Zorato)
	'http://www.web-line-studio.ru/', //author website
	'Automatical image handler after upload', //Plugin description
	'Files', //page type - on which admin tab to display
	'imagizer_settings'  //main function (administration)
);



// !!!!!!!!!!!!!!!!!!!!!!! watermark, compression, i18n !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



add_action('files-sidebar','createSideMenu',array($thisfile,'Imagizer'));
add_action('file-uploaded','imagizer_handle');


function imagizer_handle(){ 
    $config=load_config();
    $file=array();
    $file=isset($_FILES['file'])?$_FILES['file']:(isset($_FILES['Filedata'])?$_FILES['Filedata']:false);
    if ($file===false) return;

    $file['type']=is_array($file['type'])?$file['type'][0]:$file['type'];
    $file['name']=is_array($file['name'])?$file['name'][0]:$file['name'];
    $file['ext'] = lowercase(pathinfo($file['name'],PATHINFO_EXTENSION));
    
    if (!defined('GSNOUPLOADIFY')) {
        $file['target'] = str_replace('//','/',(isset($_POST['path'])) ? GSDATAUPLOADPATH.$_POST['path']."/" : GSDATAUPLOADPATH);
    }
    else {
        $file['target'] = isset($_GET['path'])?tsl("../data/uploads/".str_replace('../','', $_GET['path'])):"../data/uploads/";
    }
    $file['target'].= clean_img_name(to7bit($file['name']));
    
    $image_types=array('image/jpeg','image/pjpeg','image/png','image/gif');
    $image_ext=array('jpg','jpeg','png','gif');
 
    if (in_array($file['type'],$image_types) || in_array($file['ext'],$image_ext) ){ 
        
        include_once GSPLUGINPATH.'Imagizer/simpleimage.php';
        $image = new SimpleImage();
        $image->load($file['target']);
    
        if ($config->size=='var'){
            if ($config->priority=='min'){ //check max first, then min
                $image->checkMax((int)$config->max->width,(int)$config->max->height);
                $image->checkMin((int)$config->min->width,(int)$config->min->height);
            }
            else { //check min first, then max
                $image->checkMin((int)$config->min->width,(int)$config->min->height);
                $image->checkMax((int)$config->max->width,(int)$config->max->height);
            }
        }
        else { //exact size
            if ($config->ratio=='square'){
                $image->cropCenter((int)$config->exact->width,(int)$config->exact->height);    
            }
            else {//spoil proportions
                $image->resize((int)$config->exact->width,(int)$config->exact->height);
            }
        }
        
        $image->save($file['target'],$image->getType(),100); 

    }
}

function imagizer_settings(){
    $config=load_config();
    include GSPLUGINPATH.'Imagizer/settings_handler.php';
    save_config($config);
    include GSPLUGINPATH.'Imagizer/settings_viewer.php';
}

function load_config(){
    $c=getXML(GSPLUGINPATH.'Imagizer/config.xml');
    if (!$c){ //default configuration
        $c->ratio='save';
        $c->size='exact';
        $c->priority='max';
        $c->max->height = 1000;
        $c->max->width  = 1000;
        $c->min->height = 0;
        $c->min->width  = 0;
        $c->exact->height=300;
        $c->exact->width =300;
        save_config($c);
    }
    return $c;
}

function save_config($c){
    XMLsave($c,GSPLUGINPATH.'Imagizer/config.xml');
}